// T84_POV_Test_Accel_Max
// Tests response of Accel to max values.
//
// 89/1/17 Initial Creation - jkl
//  
//    This code is in the public domain.
//

#include <TinyWireM.h>                  // I2C Master lib for ATTinys which use USI

const int switchPin                     = 3;   // use PA3 / PCIE0 - PCINT3 / Pin 2 (Pin 10 on DIP) / Arduino Digital 3
//const int statusLED                     = 2;

const int led6 = 2;    // highest led
const int led5 = 1;
const int led4 = 0;
const int led3 = 10;
const int led2 = 9;
const int led1 = 8;
const int led0 = 7;    // Lowest led
/*
const int led6 = 7;    // highest led
const int led5 = 8;
const int led4 = 9;
const int led3 = 10;
const int led2 = 0;
const int led1 = 1;
const int led0 = 2;    // Lowest led
*/

void ledsOff() {
  digitalWrite(led0, LOW);
  digitalWrite(led1, LOW);
  digitalWrite(led2, LOW);
  digitalWrite(led3, LOW);
  digitalWrite(led4, LOW);
  digitalWrite(led5, LOW);
  digitalWrite(led6, LOW);
}
void liteLeds(byte ledCol) {
  if (ledCol & 0x01) digitalWrite(led0, HIGH);
  if (ledCol & 0x02) digitalWrite(led1, HIGH);
  if (ledCol & 0x04) digitalWrite(led2, HIGH);
  if (ledCol & 0x08) digitalWrite(led3, HIGH);
  if (ledCol & 0x10) digitalWrite(led4, HIGH);
  if (ledCol & 0x20) digitalWrite(led5, HIGH);
  if (ledCol & 0x40) digitalWrite(led6, HIGH);
}

// For the Accelerometer control

const int NUM_CMDS = 6;
const uint8_t cmds[NUM_CMDS][2] = {
  {0x20, 0x5f},   // 100Hz, LP, x,y,z en
  {0x21, 0x00},   // HP Filt off
  {0x22, 0x00},   // Interrupts off
  {0x23, 0x10},   // 00 =FS +/-2g; 10=4g;20=8g; 30=16g
  {0x24, 0x00},   // 
  {0x25, 0x00},   // 
};

void sendAccel(uint8_t reg, uint8_t cmd) {
  TinyWireM.beginTransmission(0x19); // transmit to device 0x19
  TinyWireM.write( reg);      // sets register pointer to the command register
  TinyWireM.write(cmd);      // Send data
  TinyWireM.endTransmission();      // stop transmitting
}

//uint8_t getAccel(uint8_t reg) {
int8_t getAccel(uint8_t reg) {
  //uint8_t reading = 0xff;
  int8_t reading = 0xff;
  TinyWireM.beginTransmission(0x19); // transmit to device #0x19
  TinyWireM.write(reg);      // sets register pointer
  TinyWireM.endTransmission();      // stop transmitting

  // read back
  TinyWireM.requestFrom(0x19, 1);    // request byte from slave device

  //  receive reading
  if (TinyWireM.available() >= 1) { // if byte received
    reading = TinyWireM.read();     // receive
    //Serial.println(reading,HEX);   // print the reading
  }
  return reading;
}


void setup() {
  pinMode(switchPin, INPUT);    // maybe later
  pinMode(led0, OUTPUT);
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(led4, OUTPUT);
  pinMode(led5, OUTPUT);
  pinMode(led6, OUTPUT);

  TinyWireM.begin();                // join i2c bus (address optional for master)
  for (int i = 0; i < NUM_CMDS; i++) {  // Set up the click interrupt
    sendAccel(cmds[i][0], cmds[i][1]);
  }

} // setup


void loop() {
  int8_t x_msb, y_msb;
  boolean ledOn = false;
  do {
    x_msb = getAccel(0x29);
    y_msb = getAccel(0x2b);
   // liteLeds((byte)((~y_msb) >> 1));
    //liteLeds((byte)((~x_msb) & 0xf0));
  //  delay(100);
   // ledsOff();
   /*
   if (x_msb > 0x10){  
     digitalWrite(led6, HIGH);
     ledOn = true;
   }
    else if (x_msb < -0x1c){  
     digitalWrite(led0, HIGH);
     ledOn = true;
   }
    if (y_msb > 0x0c){  
     digitalWrite(led4, HIGH);
     ledOn = true;
   }
    else if (y_msb < -0x7c){  
     digitalWrite(led2, HIGH);
     ledOn = true;
   }*/
   if (x_msb > -0x08){  
     digitalWrite(led0, HIGH);
     ledOn = true;
   }
    if (x_msb > -0x03){   
     digitalWrite(led1, HIGH);
     ledOn = true;
   }
   if (x_msb > 0x00){  
     digitalWrite(led2, HIGH);
     ledOn = true;
   }
    if (x_msb > 0x03){   
     digitalWrite(led3, HIGH);
     ledOn = true;
   }
   if (x_msb > 0x08){  
     digitalWrite(led4, HIGH);
     ledOn = true;
   }
    if (x_msb > 0x13){   
     digitalWrite(led5, HIGH);
     ledOn = true;
   }
   if (x_msb > 0x18){  
     digitalWrite(led6, HIGH);
     ledOn = true;
   }
   if (ledOn) {
    //digitalWrite(led6, HIGH);
      delay(2);
      digitalWrite(led6, LOW);
      digitalWrite(led5, LOW);
      digitalWrite(led4, LOW);
      digitalWrite(led3, LOW);
      digitalWrite(led2, LOW);
      digitalWrite(led1, LOW);
      digitalWrite(led0, LOW);
      ledOn = false;
    }
  } while (true) ;  
}

